<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Usuario extends CI_Controller {
	public function __construct()
	{
		parent::__construct();
		// Cargamos las librerias, model, helper;
		$this->load->library('form_validation');
		$this->load->model("Usuario_Model");
		$this->load->model("Proveedor_Model");

		if(!$this->session->userdata('id_usuario'))
		{
		redirect('/Login/login/');
		} 

	}

	public	function index()
	{
		
		$data = array();

        $limit_per_page = 10;
        $start_index = ($this->uri->segment(4)) ? $this->uri->segment(4) : 0;

        $total_records =$this->Usuario_Model->get_all_data();  //este modelo me trae la cantidad de registros. get_all_data() es una fucnion que nosotros creamos. la funcion indica que me traigan la cantidad(numero de registros) de la base de datos
        $data["ENCABEZADO"] ='Registros de Usuarios';

        if ($total_records > 0) 
        {
        		$data["usuario"] = $this->session->userdata('usuario');
            $data["id_usuario"] = $this->session->userdata('id_usuario');

            //$data["proveedor_lista"] =$this->Proveedor_Model->lista_proveedor();

            $data["results"] = $this->Usuario_Model->get_usuario(  $limit_per_page, $start_index );



            $config['base_url'] = base_url() . 'index.php/Usuario/usuario/index';

            $config['total_rows'] = $total_records;
            $config['per_page'] = $limit_per_page;
            $config["uri_segment"] = 4;
            $config['full_tag_open'] = '<ul class="pagination">';
            $config['full_tag_close'] = '</ul>'; 
            $config['first_link'] = 'Primero';
            $config['last_link'] = 'Último';
            $config['first_tag_open'] = '<li>';        
	        $config['first_tag_close'] = '</li>';        
	        $config['prev_link'] = '&laquo';        
	        $config['prev_tag_open'] = '<li class="prev">';        
	        $config['prev_tag_close'] = '</li>';        
	        $config['next_link'] = '&raquo';        
	        $config['next_tag_open'] = '<li>';        
	        $config['next_tag_close'] = '</li>';        
	        $config['last_tag_open'] = '<li>';        
	        $config['last_tag_close'] = '</li>';        
	        $config['cur_tag_open'] = '<li class="active"><a href="#">';        
	        $config['cur_tag_close'] = '</a></li>';        
	        $config['num_tag_open'] = '<li>';        
	        $config['num_tag_close'] = '</li>';
            
            $this->pagination->initialize($config);  //inicicalia nuetra paginacion

             
            // build paging links
            $data["links"] = $this->pagination->create_links();
            $this->parser->parse('Index/head.php',$data, FALSE);
						

            if ($this->session->userdata('rol')=="Alumno")
						{
							$this->parser->parse('Index/menu_alumno.php', $data, FALSE);
							 	$this->parser->parse('Usuario/usuario_datos.php',$data, FALSE);
						}
						else
						{
							$this->parser->parse('Index/menu.php', $data, FALSE);
							 	$this->parser->parse('Usuario/usuario_datos.php',$data, FALSE);
						}
						$this->load->view('Index/pie.php'); 		
			
	}
}
		

	public function save_edit()
	{
		$id_usuario =  $this->uri->segment(4,0);
		if ($this->input->post('usuario_edit') != $this->input->post('usuario_edit_anterior'))
		{
			$datos = $this->db->query('select * from usuario where usuario="'.$this->input->post('usuario_edit').'"' );
			if ($datos->num_rows() > 0) 
			{
				$data = array 
				(
					'ENCABEZADO'=> 'Usuario',
					"id_usuario"    => $this->session->userdata('id_usuario'),
					"usuario"    => $this->session->userdata('usuario'),
					"proveedor_lista" => $this->Proveedor_Model->lista_proveedor(),
					"error_usuario" => "El Usuario ya existe. !!!"
										
				);
	        	 $this->parser->parse('Index/head.php', $data);	
				 $this->parser->parse('Index/menu.php',$data ); 
		         $this->parser->parse('Usuario/usuario_error.php',$data);
		         $this->load->view('Index/pie.php');
			}
			else
			{
				$data = array(
	    	 	'usuario' => $this->input->post('usuario_edit') , 
	    	 	'pass' => $this->input->post('pass_edit') , 
	    	 	'nombre' =>$this->input->post('nombre_edit'),
	    	 	);
				$this->Usuario_Model->save_edit($id_usuario,$data);

				redirect('/Login/login/logout');

			}

		}
		else
			{
				$data = array(
	    	 	'usuario' => $this->input->post('usuario_edit') , 
	    	 	'pass' => $this->input->post('pass_edit') , 
	    	 	'nombre' =>$this->input->post('nombre_edit'),
	    	 	);
				$this->Usuario_Model->save_edit($id_usuario,$data);

				redirect('/Login/login/logout');
			}

		
	}
	
	public function adding ()
	{
		$datos = $this->db->query('select * from usuario where usuario="'.$this->input->post('usuario_add').'"' );
		if ($datos->num_rows() > 0) 
		{
			$data = array 
			(
				'ENCABEZADO'=> 'Usuario',
				"id_usuario"    => $this->session->userdata('id_usuario'),
				"usuario"    => $this->session->userdata('usuario'),
				"proveedor_lista" => $this->Proveedor_Model->lista_proveedor(),
				"error_usuario" => "El Usuario ya existe. !!!"
									
			);
        	 $this->parser->parse('Index/head.php', $data);	
			 $this->parser->parse('Index/menu.php',$data ); 
	         $this->parser->parse('Usuario/usuario_error.php',$data);
	         $this->load->view('Index/pie.php');
		} 
		else
		{
			$data = array 
			(
				'usuario'=> $this->input->post('usuario_add'),
				'pass' =>   $this->input->post('pass_add'),
				"nombre" => $this->input->post('nombre_add'),
				"rol" => $this->input->post('rol'),
			);
			$this->Usuario_Model->add_usuario($data);
			redirect('/Usuario/usuario');
		}

		

		
	}

	public function edit()
	{

		$id    = $this->uri->segment(4,0);	
		$query = $this->Usuario_Model->edit($id);
		$unidades= $this->Usuario_Model->unidades2();
	
		if ($query != false)
		{
			$data = array 
			(
					
					'titulo'=> 'Modificar Usuario',//mi titulo 
					"usuario" => $this->session->userdata('usuario'),
					'formulario'=> $query,
					"unidad2" => $unidades,
					"permiso" => $this->session->userdata('permiso'),
					"nombre" => $this->session->userdata('nombre'),
					"denominacion" => $this->session->userdata('denominacion'),
					
			);
			$this->parser->parse('Index/head.php',$data, FALSE);	// carga todos las url de estilo i js home	
			$this->parser->parse('Index/menu.php',$data, FALSE); // esta seria la barra de navegacion horizontal
			$this->parser->parse('Usuario/usuario_edit.php',$data, FALSE); // este seria todo el contenido central
			$this->load->view('Index/pie.php'); // pie con los js
		}
		else
		{

			return false;			
		}
		
	}


	
	function delete_usuario()
	{
		
		$id_usuario=$this->uri->segment(4,0);
		
		
        if ($id_usuario==1)
        {
        	$data = array 
			(
				'ENCABEZADO'=> 'Usuario',
				"id_usuario"    => $this->session->userdata('id_usuario'),
				"usuario"    => $this->session->userdata('usuario'),
				"proveedor_lista" => $this->Proveedor_Model->lista_proveedor(),
				"error_usuario" => "El Usuario Administrador no puede ser eliminado. !!!"
									
			);
        	 $this->parser->parse('Index/head.php', $data);	
			 $this->parser->parse('Index/menu.php',$data ); 
	         $this->parser->parse('Usuario/usuario_error.php',$data);
	         $this->load->view('Index/pie.php'); 
        }
        else
        {
        	$this->Usuario_Model->delete($id_usuario);
        	redirect('/Usuario/usuario');
        }

			
	}

	function fetch_user_usuario()
	{  
			$fetch_data = $this->Usuario_Model->consulta_usuario_vista(); 
           

           $data = array();  
           foreach($fetch_data as $row)  
           {  
           		$ver_detalle="";
           		$edit="";
           		$delete="";

           		$sub_array = array();  
                $sub_array[] =  $row->id_usuario;  
                $sub_array[] =  $row->nombre;
                $sub_array[] = $row->usuario;  
               

               if ($row->id_usuario!=1)
               {
               	 $ver_detalle='<a class="btn btn-primary btn-sm" data-toggle="modal" href="#'.$row->id_usuario.'"  ><i ></i>Ver</a>&nbsp;';
               }
               else
               {
               	$ver_detalle='';
               }

               $edit='<a class="btn btn-success btn-sm"  data-toggle="modal" href="#edit'.$row->id_usuario.'"><i class="glyphicon glyphicon-edit"></i></a>&nbsp;';

                $delete='<a class="btn btn-danger btn-sm" onclick="delete_row_usuario('.$row->id_usuario.','.$this->session->userdata('id_usuario').')" ><i class="glyphicon glyphicon-trash"></i></a>&nbsp;';

                $modal_edit=' <div class="modal fade" id="edit'.$row->id_usuario.'" style="z-index: 100001"  role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="exampleModalLongTitle">Editar Usuario</h5>
                  <button type="button" class="close"  data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                <form   method="post" name="formulario_usuario" id="formulario_usuario" 
                action="'.base_url().'index.php/Usuario/Usuario/save_edit/'.$row->id_usuario.'" enctype="multipart/form-data">

                  <table class="table table-striped">

                    <tr >
                      <th colspan="2">
                        Nombre
                      </th>
                   
                      <td  colspan="2">
                         <input type="text" required  name="nombre_edit" id="nombre_edit" class="form-control" value="'.$row->nombre.'">     
                        
                      </td>
                    </tr>
                    <tr >
                      <th colspan="2">
                        Usuario
                      </th>
                   
                      <td  colspan="2">
                         <input type="text" required  name="usuario_edit" id="usuario_edit" class="form-control" value="'.$row->usuario.'"> 
                         <input type="text"   name="usuario_edit_anterior" id="usuario_edit_anterior"  value="'.$row->usuario.'" hidden>     
                        
                      </td>
                    </tr>
                    <tr >
                      <th colspan="2">
                        Contraseña
                      </th>
                   
                      <td  colspan="2">
                         <input type="text" required  name="pass_edit" id="pass_edit" class="form-control" value="'.$row->pass.'">     
                        
                      </td>
                    </tr>
                     <tr >
                      <th colspan="2">
                       
                      </th>
                   
                      <td  colspan="2">
                            
                         <button type="submit" class="btn btn-success" >Confirmar</button>
                      </td>
                    </tr>



                                       
	                
                 </table>
                 
                 </form>  
                </div>
                <div class="modal-footer">
                  
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
                
                
                </div>
              
              </div>
            </div>
          </div> ';

          $modal_ver_detalle=' <div class="modal fade" id="'.$row->id_usuario.'" style="z-index: 100001"  role="dialog" aria-labelledby="exampleModalCenterTitle" aria-hidden="true">
            <div class="modal-dialog modal-dialog-centered" role="document">
              <div class="modal-content">
                <div class="modal-header">
                  <h5 class="modal-title" id="exampleModalLongTitle">Detalles de Usuario: '.$row->nombre.'</h5>
                  <button type="button" class="close"  data-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                  </button>
                </div>
                <div class="modal-body">
                	<table class="table table-striped">
                	<thead>
                            <tr class="active">                               
                                <th>Usuario</th>
                                <th>Contraseña</th>
                                
                            </tr>
                    </thead>
                    <tr >
                      <td> '.$row->usuario.'   
                      </td>
                       <td> '.$row->pass.'
                      </td>
                                                                                           
                    </tr>
                   
                 </table>
                  
                
                </div>
                <div class="modal-footer">
                  
                  <button type="button" class="btn btn-secondary" data-dismiss="modal">Cerrar</button>
                
                
                </div>
              
              </div>
            </div>
          </div> ';

          		if ($row->id_usuario==1)
          		{
          			 $sub_array[] =$edit.$modal_edit;
          		}
          		else
          		{
          			 $sub_array[] =$ver_detalle.$edit.$delete.$modal_edit.$modal_ver_detalle; 
          		}

                
                $data[] = $sub_array;  
          		
           }

                $output = array(  
                "draw"                    =>     intval($this->input->post("draw")),  
                "recordsTotal"          =>      $this->Usuario_Model->get_all_data_usuario_vista(),  
                "recordsFiltered"     =>     	$this->Usuario_Model->get_filtered_usuario_vista(),  
                "data"                    =>     $data  
           );  
           echo json_encode($output);  
      }  
    ///////////////////////////////////////////////////////////////////////////////////////





}

