<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Factura_Model extends CI_Model {
	var $column_order = array('factura.num_factura', 'alumno.nombre','alumno.apellido','tipo_venta','estado'); //set column field database for datatable orderable


	public function __construct()
	{
		parent::__construct();
		
	}
/////////////////////////////////////////////////////////////////////////
	function  add_factura($num_factura, $total_factura)
	{	
			
		///realizamos consulta para ver si existe nuestra carga anterior a la bd
		$this->db->where('detalle_factura.num_factura',$num_factura);
		$this->db->join('factura', 'factura.num_factura = detalle_factura.num_factura');
		$this->db->join('alumno', 'alumno.id_alumno = factura.id_alumno');
		$this->db->join('producto', 'producto.id_producto = detalle_factura.id_producto');
		$query = $this->db->get('detalle_factura');

		if ($query->num_rows() > 0) {
		return $query->result();
		} else
		return false;
		
	}
	///////////////////////////////////////////////77
	
	public function get_total_busqueda($num_factura_buscar,$alumno_buscar,$fecha_buscar1,$fecha_buscar2,$tipo_venta_buscar,$estado_buscar,$forma_pago_buscar) 
    {
    	 $this->db->from("factura"); 
    	 $this->db->join('alumno', 'factura.id_alumno=alumno.id_alumno');
    	  if($num_factura_buscar!="")
	      	{
	      		$this->db->where("factura.num_factura", $num_factura_buscar);  
	      	}
	      	if($alumno_buscar!="")
	      	{
	      		$this->db->like("alumno.nombre", $alumno_buscar);  
	      		$this->db->or_like("alumno.apellido", $alumno_buscar);
	      	}
	      	if($fecha_buscar1!="" && $fecha_buscar2!="")
	      	{
	      		$this->db->where('factura.fecha BETWEEN "'. date('Y-m-d', strtotime($fecha_buscar1)). '" and "'. date('Y-m-d', strtotime($fecha_buscar2)).'"');
	      	}
	      	if($tipo_venta_buscar!="")
	      	{
	      		$this->db->where("factura.tipo_venta", $tipo_venta_buscar);  
	      	}
	      	if($estado_buscar!="")
	      	{
	      		$this->db->where("factura.estado", $estado_buscar);  
	      	}
	      	if($forma_pago_buscar!="")
	      	{
	      		$this->db->where("factura.forma_pago", $forma_pago_buscar);  
	      	}

         
    	 return $this->db->count_all_results();  
    }
    //////////////////////////////////////////////////
    public function get_total($usuario,$rol) 
    {
    	//////////buscaremos cedula del alumno
    	$this->db->where('cedula',$usuario);
		$consulta = $this->db->get('alumno');
		if ($consulta->num_rows() > 0) 
        {
        	$fila = $consulta->row_array();
			$id_alumno= $fila['id_alumno'];
        }
        else
        {
        	$id_alumno=0;
        }

		//////////


    	$this->db->from("factura"); 
    	$this->db->join('alumno', 'factura.id_alumno=alumno.id_alumno');
    	if ($rol=="Alumno") 
    	{
    		$this->db->where("factura.id_alumno", $id_alumno); 
    	}

    	
    	 return $this->db->count_all_results();  
    }


    public function get_factura($limit, $start, $usuario,$rol) 
    {

    	//////////buscaremos cedula del alumno
    	$this->db->where('cedula',$usuario);
		$consulta = $this->db->get('alumno');
		if ($consulta->num_rows() > 0) 
        {
        	$fila = $consulta->row_array();
			$id_alumno= $fila['id_alumno'];
        }
        else
        {
        	$id_alumno=0;
        }
		
		//////////



    	$this->db->select("factura.importe as importe,factura.id_factura as id_factura,factura.num_factura as num_factura,DATE_FORMAT(factura.fecha,'%d-%m-%Y') as fecha,CASE factura.tipo_venta WHEN 1 THEN 'Contado' WHEN 2 THEN 'Credito' END AS tipo_venta,alumno.cedula as cedula,alumno.nombre as nombre, alumno.apellido as apellido,CASE factura.estado WHEN 0 THEN 'A pagar' WHEN 1 THEN 'Pagado' WHEN 2 THEN 'Anulado' END AS estado,factura.tipo_venta as id_tipo_venta, factura.estado as id_estado, CASE factura.forma_pago WHEN 1 THEN 'Efectivo' WHEN 2 THEN 'Tarjeta' END as forma_pago, factura.forma_pago as id_forma_pago");
    	 $this->db->from("factura");
    	 $this->db->join('alumno', 'factura.id_alumno=alumno.id_alumno');

    	 if ($rol=="Alumno") 
	    	{
	    		$this->db->where("factura.id_alumno", $id_alumno); 
	    	}


    	 $this->db->order_by('num_factura', 'desc');  
    	         
        $this->db->limit($limit, $start);
        $query = $this->db->get();
 
        if ($query->num_rows() > 0) 
        {
            foreach ($query->result() as $row) 
            {
                $data[] = $row;
            }
             
            return $data;
        }
 
        return false;
    }

     public function get_factura_busqueda($limit, $start, $num_factura_buscar,$alumno_buscar,$fecha_buscar1,$fecha_buscar2,$tipo_venta_buscar,$estado_buscar,$forma_pago_buscar) 
    {
    	$this->db->select("factura.importe as importe, factura.id_factura as id_factura,factura.num_factura as num_factura,DATE_FORMAT(factura.fecha,'%d-%m-%Y') as fecha,CASE factura.tipo_venta WHEN 1 THEN 'Contado' WHEN 2 THEN 'Credito' END AS tipo_venta,alumno.cedula as cedula,alumno.nombre as nombre, alumno.apellido as apellido,CASE factura.estado WHEN 0 THEN 'A pagar' WHEN 1 THEN 'Pagado' WHEN 2 THEN 'Anulado' END AS estado,factura.tipo_venta as id_tipo_venta, factura.estado as id_estado, CASE factura.forma_pago WHEN 1 THEN 'Efectivo' WHEN 2 THEN 'Tarjeta' END as forma_pago, factura.forma_pago as id_forma_pago");
    	 $this->db->from("factura");
    	 $this->db->join('alumno', 'factura.id_alumno=alumno.id_alumno');

    	 if($num_factura_buscar!="")
	      	{
	      		$this->db->where("num_factura", $num_factura_buscar);  
	      	}
	      	if($alumno_buscar!="")
	      	{
	      		
	      		$this->db->like("nombre", $alumno_buscar);  
	      		$this->db->or_like("apellido", $alumno_buscar);
	      		$this->db->or_like("cedula", $alumno_buscar);
	      		
	      	}
	      	if($fecha_buscar1!="" && $fecha_buscar2!="")
	      	{
	      		$this->db->where('fecha BETWEEN "'. date('Y-m-d', strtotime($fecha_buscar1)). '" and "'. date('Y-m-d', strtotime($fecha_buscar2)).'"');
	      	}
	      	if($tipo_venta_buscar!="")
	      	{
	      		$this->db->where("factura.tipo_venta", $tipo_venta_buscar);  
	      	}
	      	if($estado_buscar!="")
	      	{
	      		$this->db->where("factura.estado", $estado_buscar);  
	      	}
	      	if($forma_pago_buscar!="")
	      	{
	      		$this->db->where("factura.forma_pago", $forma_pago_buscar);  
	      	}
	      	 $this->db->order_by('num_factura', 'desc');  

    	         
        $this->db->limit($limit, $start);
        $query = $this->db->get();
 
        if ($query->num_rows() > 0) 
        {
            foreach ($query->result() as $row) 
            {
                $data[] = $row;
            }
             
            return $data;
        }
 
        return false;
    }


    ////////////////////////////////////////////////
    public function get_total_compra() 
    {
    	 $this->db->from("compra"); 
          
    	 return $this->db->count_all_results();  
    }

    public function get_factura_compra($limit, $start ) 
    {
    	$this->db->select("*,CASE compra.tipo_compra	WHEN  1 then 'Contado' 	when 2 then 'Crédito' end as tipo_compra, compra.tipo_compra as id_tipo_compra,	CASE compra.estado	WHEN  1 then 'Pagado' when 0 then 'A pagar' end as estado, compra.estado as id_estado1,compra.id_proveedor as id_proveedor1,DATE_FORMAT(compra.fecha_compra,'%d-%m-%Y') as fecha_compra ");  
           $this->db->from("compra"); 
           $this->db->join('proveedor', 'proveedor.id_proveedor=compra.id_proveedor');

        $this->db->limit($limit, $start);
        $query = $this->db->get();
 
        if ($query->num_rows() > 0) 
        {
            foreach ($query->result() as $row) 
            {
                $data[] = $row;
            }
             
            return $data;
        }
 
        return false;
    }



	
	////////////////////////////////////////////////7
	public function obtenerFactura($num_factura)
    {
       $this->db->where('num_factura',$num_factura);
	   $query = $this->db->get(' detalle_factura INNER JOIN factura ON detalle_factura.num_factura =factura.num_factura inner join producto on detalle_factura.producto=producto.codigo inner join alumno on alumno.ci=factura.ci');
	   if ($query->num_rows() > 0) {
	   return $query->result();
	   } else
		return false;
    }
	///////////////////////////////////////////////////
	function ver_detalle ($num_factura)
	{
		
		$sql=" select detalle_factura.id_detalle as id_detalle, factura.num_factura,detalle_factura.cantidad, detalle_factura.precio as precio,detalle_factura.iva as iva , descripcion, total_iva, codigo,
		CASE factura.tipo_venta
			WHEN  1 then 'Contado' 
			when 2 then 'Crédito' 
			end as tipo_venta,
		CASE iva
			when 0 then 'Exento'
			WHEN 10 then '10%'
			when 5 then '5%'
			end as iva_nombre,
			 precio * detalle_factura.cantidad AS subtotal


		from detalle_factura
		INNER JOIN factura ON detalle_factura.num_factura =factura.num_factura 
		inner join 
		( 	select
		 producto.id_producto as id_producto, producto.codigo as codigo, producto.cantidad as cantidad,descripcion

		from producto 
	
		) as
		producto on detalle_factura.id_producto=producto.id_producto where factura.num_factura =".$num_factura;
		

		//$sql="select * from detalle_factura where num_factura=".$num_factura;
		$query = $this->db->query($sql);
		
		
		if ($query->num_rows() > 0) {
			return $query->result();
		} else
			return false;
			
	
	}
	////////////////////////////////
	function detalle_suma ($num_factura)
	{
	
	$sql='SELECT  count(detalle_factura.num_factura) as total_cantidad, Sum(detalle_factura.total_iva) as total_iva, Sum(detalle_factura.precio) as total_factura';
	$sql=$sql.' FROM detalle_factura,factura where detalle_factura.num_factura=factura.num_factura and detalle_factura.num_factura='.$num_factura;
	$consulta = $this->db->query($sql);
	
	if ($consulta->num_rows() > 0) {
		return $consulta->result();
	} else
		return false;

	}
	
	//////////////////////////////////////////////////77
	function buscar ($dato_buscar)
	{
	
	//$this->db->where('factura.num_factura',$dato_buscar);
	$this->db->like('alumno.nombre', $dato_buscar, 'before');
	$query = $this->db->get(' factura INNER JOIN alumno ON alumno.ci =factura.ci');//mi consulta sql
	//VALIDAR SI TENEMOS REGISTRO 
	if ($query->num_rows() > 0) {
		return $query->result();
	} else
		return false;

	}
	///////////////////////////////////////////////////
	
	//////////////////////////////////////////////////////////77
	public function datos_alumno()
	{
		$this->db->order_by('cedula','desc');
		$query = $this->db->get('alumno');
		if($query->num_rows()>0)
		{
			return $query->result();
		}
		
		
	}
	public function datos_producto()
	{
		
		
		$this->db->join('proveedor','proveedor.id_proveedor=producto.id_proveedor');
		$this->db->join('marca','marca.id_marca=producto.id_marca');
		$this->db->join('categoria','categoria.id_categoria=producto.id_categoria');
		
		$codigo = $this->db->get('producto');
		if($codigo->num_rows()>0)
		{
			return $codigo->result();
		}
		
	}
	public function maximo_factura()
	{
		$this->db->select_max('num_factura');
		$num_factura = $this->db->get('factura');
		if($num_factura->num_rows()>0)
		{
			return $num_factura->result();
		}
		
	}
	
	////////////////////////////////7
	public function dato_facturas($factura_numero)
	{
		$sql='select * from factura inner join detalle_factura on factura.num_factura=detalle_factura.num_factura';
		$sql=$sql.' inner join producto on detalle_factura.producto=producto.id_prodcuto ';
		$sql=$sql.' inner join alumno on factura.id_alumno=alumno.id_alumno ';

		$sql=$sql.' where  factura.num_factura='.$factura_numero;
		$dato_facturas = $this->db->query($sql); 
		if ($dato_facturas->num_rows() > 0) 
		{
			return $dato_facturas->result();
		}
		else
		{
			return false;
		}
	}
	//////////////////////////////////////////////////////////7
	
	public function adding_dato_factura($dato_factura)
	{
		$this->db->insert('factura',$dato_factura);

	}
	////////////////////////////////////////////////////////
	public function adding_detalle_factura($detalle_factura)
	{
		
		$this->db->insert('detalle_factura',$detalle_factura);

	}
	public function adding_credito($dato_credito)
	{
		$this->db->insert('credito',$dato_credito);

	}

	/////////////////////////////////////////////////////////////compra de mercaderai
	/////////////////////////////////////////////////////////////////////////
	function make_query()  
      {  
           $this->db->select("*,CASE compra.tipo_compra	WHEN  1 then 'Contado' 	when 2 then 'Crédito' end as tipo_compra, compra.tipo_compra as id_tipo_compra,	CASE compra.estado	WHEN  1 then 'Pagado' when 0 then 'A pagar' end as estado, compra.estado as id_estado1,compra.id_proveedor as id_proveedor1,DATE_FORMAT(compra.fecha_compra,'%d-%m-%Y') as fecha_compra ");  
           $this->db->from("compra"); 
           $this->db->join('proveedor', 'proveedor.id_proveedor=compra.id_proveedor');
          
           if(isset($_POST["search"]["value"]))  
           {  
                $this->db->like("proveedor.proveedor", $_POST["search"]["value"]);  
                $this->db->or_like("producto.descripcion", $_POST["search"]["value"]);  
           }  
          if(isset($_POST["order"]))
           {  
               //$this->db->order_by($this->order_column[$_POST['order']['0']['column']], $_POST['order']['0']['dir']);  
           }  
           else  
           {  
                $this->db->order_by('id_compra', 'desc');  
           }  
      }

      function make_datatables()
      {  
           $this->make_query(); 
           if(  intval($this->input->post("length"))  != -1)  
           {  
                $this->db->limit(intval($this->input->post("length")), intval($this->input->post("start")));  
           }  
           $query = $this->db->get();  
           return $query->result();  
      } 

      function get_filtered_data()
      {  
           $this->make_query();  
           $query = $this->db->get();  
           return $query->num_rows();  
      }  

      function get_all_data()  
      {  
           $this->db->select("*");  
           $this->db->from("compra");  
           return $this->db->count_all_results();  
      }  
     /////////////////////////////////////////////////////////////////////////
      function delete_compra ($id_compra)
      {
		$this->db->where('id_compra',$id_compra);
		$this->db->delete('compra');//mi consulta sql

		$this->db->where('id_compra',$id_compra);
		$this->db->delete('detalle_compra');//mi consulta sql
		}

	//////////////////////////////////////////////////////////////
	function delete_factura ($num_factura)
      {
		$this->db->where('num_factura',$num_factura);
		$this->db->delete('factura');//mi consulta sql

		$this->db->where('num_factura',$num_factura);
		$this->db->delete('detalle_factura');//mi consulta sql
		}
		 /////////////////////////////////////////////////////////////////////////
      function anulacion_factura ($num_factura)
      {
      		$this->db->set('estado', 2);
			$this->db->where('num_factura', $num_factura);
			$this->db->update('factura');
	}

	//////////////////////////////////////////////////////////////



		///////////////////////////////////////FACTURTA ALL
	/////////////////////////////////////////////////////////////////////////
	function make_query_factura_all($condicion)  
      {  
          		
		
			$this->db->select("*,factura.id_factura as id_factura,factura.num_factura as num_factura,DATE_FORMAT(factura.fecha,'%d-%m-%Y') as fecha,CASE factura.tipo_venta WHEN 1 THEN 'Contado' WHEN 2 THEN 'Credito' END AS tipo_venta,alumno.cedula as cedula ruc,alumno.nombre as nombre, alumno.apellido as apellido,CASE factura.estado WHEN 0 THEN 'A pagar' WHEN 1 THEN 'Pagado' WHEN 2 THEN 'Anulado' END AS estado,factura.tipo_venta as id_tipo_venta, factura.estado as id_estado, CASE factura.forma_pago WHEN 1 THEN 'Efectivo' WHEN 2 THEN 'Tarjeta' END as forma_pago, factura.forma_pago as id_forma_pago");

           $this->db->from("factura"); 
           $this->db->join('alumno', 'factura.id_alumno=alumno.id_alumno');
           if ($condicion==1)
          	{    $this->db->where("factura.tipo_venta",$condicion);        	}
           if ($condicion==2)
          	{    $this->db->where("factura.tipo_venta",$condicion);        	}

          
           if(isset($_POST["search"]["value"]))  
           {  
                $this->db->like("nombre", $_POST["search"]["value"]);  
                $this->db->or_like("apellido", $_POST["search"]["value"]);  
           }  
          if(isset($_POST["order"]))
           {  
               $this->db->order_by($_POST['order']['0']['column'],$_POST['order']['0']['dir']);  
           }  
           else  
           {  
                $this->db->order_by('factura.num_factura', 'desc');  
           }  
      }

      function make_datatables_factura_all($condicion)
      {  
           $this->make_query_factura_all($condicion); 
           if(  intval($this->input->post("length"))  != -1)  
           {  
                $this->db->limit(intval($this->input->post("length")), intval($this->input->post("start")));  
           }  
           $query = $this->db->get();  
           return $query->result();  
      } 

      function get_filtered_data_factura_all($condicion)
      {  
           $this->make_query_factura_all($condicion);  
           $query = $this->db->get();  
           return $query->num_rows();  
      }  

      function get_all_data_factura_all($condicion)  
      {  
           $this->db->select("*");  
           $this->db->from("factura"); 
           if ($condicion==1)
          	{    $this->db->where("factura.tipo_venta",$condicion);        	}
          if ($condicion==2)
          	{    $this->db->where("factura.tipo_venta",$condicion);        	} 
           return $this->db->count_all_results();  
      }  

      function alumno_ticket($num_factura)
    {
         $this->db->select("alumno.cedula as cedula, CONCAT(alumno.nombre,' ',alumno.apellido) as alumno, CASE factura.tipo_venta WHEN  1 then 'Contado'  when 2 then 'Crédito' end as tipo_venta,CASE factura.forma_pago WHEN  1 then 'Efectivo'  when 2 then 'Tarjeta' end as forma_pago");
         $this->db->from("factura");
         $this->db->join('alumno', 'alumno.id_alumno = factura.id_alumno');
         $this->db->where('factura.num_factura',$num_factura);
          $alumno_ticket = $this->db->get();
        return $alumno_ticket->result();
    }
    function imprimir_ticket($num_factura)
    {
        $this->db->select("producto.codigo as codigo, detalle_factura.cantidad as cantidad_producto, producto.descripcion as descripcion_producto, detalle_factura.precio as precio_unitario, (detalle_factura.precio*detalle_factura.cantidad) as subtotal");
        $this->db->from("detalle_factura");
       // $this->db->join('factura', 'factura.num_factura = detalle_factura.num_factura');
       // $this->db->join('alumno', 'alumno.id_alumno = factura.id_alumno');
        $this->db->join('producto', 'producto.id_producto = detalle_factura.id_producto');
        $this->db->where('detalle_factura.num_factura',$num_factura);
        $imprimir_ticket = $this->db->get();
        return $imprimir_ticket->result();
    }
    function total_subtotal($num_factura)
    {

        $total_subtotal = $this->db->query("select sum(total_iva) as total_iva, Sum(detalle_factura.precio*detalle_factura.cantidad) as total_factura FROM detalle_factura,factura where detalle_factura.num_factura=factura.num_factura and detalle_factura.num_factura=".$num_factura);
        return $total_subtotal->result();
    }
    function efectivo_vuelto($num_factura)
    {
        $this->db->select("monto_efectivo, forma_pago, monto_vuelto");
        $this->db->from("factura");
      
        $this->db->where('factura.num_factura',$num_factura);
        $efectivo_vuelto = $this->db->get();
        return $efectivo_vuelto->result();
    }

     /////////////////////////////////////////////////////////////////////////
     /*function delete_compra ($id_compra)
      {
		$this->db->where('id_compra',$id_compra);
		$this->db->delete('compra');//mi consulta sql

		$this->db->where('id_compra',$id_compra);
		$this->db->delete('detalle_compra');//mi consulta sql
		}
*/
	//////////////////////////////////////////////////////////////



}

