<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Factura extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
		
		$this->load->library('form_validation');
		$this->load->library('cart');
		$this->load->library("EscPos.php");
		$this->load->library('pagination');
		 $this->load->helper('url');
		$this->load->model("Factura_model");
		$this->load->model("Alumno_model");
		$this->load->model("Producto_model");
		$this->load->model("Proveedor_model");
		

		
		if(!$this->session->userdata('id_usuario'))
		{
		redirect('/Login/');
		} 
		
	}
	public function index()
	{
		$num_factura_buscar= $this->input->post('num_factura_buscar'); 
		$alumno_buscar= $this->input->post('alumno_buscar');
		$fecha_buscar1= $this->input->post('fecha_buscar1');
		$fecha_buscar2= $this->input->post('fecha_buscar2');
		$tipo_venta_buscar= $this->input->post('tipo_venta_buscar');
		$estado_buscar= $this->input->post('estado_buscar');
		$forma_pago_buscar= $this->input->post('forma_pago_buscar');
		

		$data = array();
        $limit_per_page = 10;
        $start_index = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;
        $total_records =$this->Factura_model->get_total(  $num_factura_buscar,$alumno_buscar,$fecha_buscar1,$fecha_buscar2,$tipo_venta_buscar,$estado_buscar,$forma_pago_buscar,$this->session->userdata('usuario'),$this->session->userdata('rol') );
         $data["usuario"] = $this->session->userdata('usuario');
			   
        $data["ENCABEZADO"] ='Facturación General';
        $data["subtitulo"] ='Todos';
        $data["id_usuario"] = $this->session->userdata('id_usuario');
        $data["nombre"] = $this->session->userdata('nombre');
        $data["rol"] = $this->session->userdata('rol');
        $data["alumno_buscar"]=$alumno_buscar;
        $data["num_factura_buscar"]=$num_factura_buscar;
        $data["results"] = $this->Factura_model->get_factura($limit_per_page, $start_index,$num_factura_buscar,$alumno_buscar,$fecha_buscar1,$fecha_buscar2,$tipo_venta_buscar,$estado_buscar,$forma_pago_buscar,$this->session->userdata('usuario'),$this->session->userdata('rol') );
		$data["total_records"] = $total_records;
		 
		 
        $config['base_url'] = base_url() . 'index.php/Factura/index';
        $config['total_rows'] = $total_records;
        $config['per_page'] = $limit_per_page;
        $config["uri_segment"] = 3;
        $config['full_tag_open'] = '<ul class="pagination">';
        $config['full_tag_close'] = '</ul>'; 
        $config['first_link'] = 'Primero';
        $config['last_link'] = 'Último';
        $config['first_tag_open'] = '<li>';        
	    $config['first_tag_close'] = '</li>';        
	    $config['prev_link'] = '&laquo';        
	    $config['prev_tag_open'] = '<li class="prev">';        
	    $config['prev_tag_close'] = '</li>';        
	    $config['next_link'] = '&raquo';        
	    $config['next_tag_open'] = '<li>';        
	    $config['next_tag_close'] = '</li>';        
	    $config['last_tag_open'] = '<li>';        
	    $config['last_tag_close'] = '</li>';        
	    $config['cur_tag_open'] = '<li class="active"><a href="#">';        
	    $config['cur_tag_close'] = '</a></li>';        
	    $config['num_tag_open'] = '<li>';        
	    $config['num_tag_close'] = '</li>';
            
            $this->pagination->initialize($config);
            $data["links"] = $this->pagination->create_links();
            
            $this->parser->parse('Index/head.php', $data, FALSE);
            if ($this->session->userdata('rol')=="Alumno")
			{
				$this->parser->parse('Index/menu_alumno.php', $data, FALSE);
				$this->parser->parse('Factura/factura_vista_alumno.php',$data, FALSE); 
			}
			else
			{
				$this->parser->parse('Index/menu.php', $data, FALSE);
				$this->parser->parse('Factura/factura_vista.php',$data, FALSE);
			}
			$this->load->view('Index/pie.php'); 
	}


	////////////////////////////////////////////////////////////////////////////////////////////////
	public function add()
	{
		$mayor =$this->Factura_model->maximo_factura();
		foreach($mayor as $fila1)
			{
			 $mayor1=intval( $fila1 -> num_factura); 
			}
		$this->db->where('detalle_factura.num_factura', $mayor1);
		$this->db->select('detalle_factura.cantidad as cantidad, detalle_factura.precio as precio,
		producto.codigo as codigo,
		detalle_factura.total_iva as total_iva,
		detalle_factura.iva as iva,');
		$this->db->join('factura','detalle_factura.num_factura=factura.num_factura');
		$this->db->join('producto','detalle_factura.id_producto=producto.id_producto');

		$query2 = $this->db->get(' detalle_factura');
	
		$data = array 
		(
					
			'num_factura'=> $this->Factura_model->maximo_factura(),
			'cedula'=> $this->Factura_model->datos_alumno(),
			"usuario" => $this->session->userdata('usuario'),
			"id_usuario"    => $this->session->userdata('id_usuario'),
		);	
		$data["nombre"] = $this->session->userdata('nombre');
        $data["rol"] = $this->session->userdata('rol');
		$this->parser->parse('Index/head.php', $data, FALSE);	
		$this->parser->parse('Index/menu.php',$data,FALSE); 
		$this->parser->parse('Factura/factura_add.php', $data);
		$this->load->view('Index/pie.php'); 
	}
	/////////////////////////////////////////////////////////////////////////////////////////////


	public function adding ()
	{
		date_default_timezone_set("America/Asuncion");


		$id_producto = $this->input->get_post('id_producto',true); 
		$cantidad = $this->input->post('cantidad'); 
		$subtotal = $this->input->post('subtotal');
		$iva = $this->input->post('iva'); 
		$subtotal_iva = $this->input->post('subtotal_iva');
		$precio = $this->input->post('precio');
		$cantidad_item = $this->input->post('cantidad_item');
		$codigo2 = $this->input->post('codigo2');
		$monto_efectivo = $this->input->post('efectivo_modal');
		$monto_vuelto = $this->input->post('vuelto_modal');
		$observacion_factura = $this->input->post('observacion_factura');
		$add_fecha_expedicion = $this->input->post('add_fecha_expedicion');
		//var_dump($precio);
		//var_dump($this->input->post('codigo2'));
		$this->db->trans_start();
		if ($this->input->post('add_fecha_expedicion')!="")
		{
		    $add_fecha_expedicion = $this->input->post('add_fecha_expedicion');
		}
		else
		{
			$add_fecha_expedicion = date("Y-m-d");
		}
		    

		if ($this->input->post('nuevo_cedula_ruc')!="" && $this->input->post('nuevo_nombre')!="")
		{
			$alumno_nuevo  = array 
				(
				'id_alumno'=> '',
				'cedula'=> $this->input->post('nuevo_cedula_ruc'), 
				'nombre'=> $this->input->post('nuevo_nombre'), 
				"apellido" => $this->input->post('nuevo_apellido'),
				);
			$this->Alumno_Model->add_alumno($alumno_nuevo);	
			$id_alumno=$this->db->insert_id();

		}
		else
		{
			$id_alumno = $this->input->post('id_alumno'); 
		}

		
		if($id_alumno=="" or $id_alumno=="0" ){$id_alumno=1;}
		$tipo_venta = $this->input->post('tipo_venta');
		$forma_pago = $this->input->post('forma_pago');
		if($forma_pago!=3)
		{
			$forma_pago_subsidio=0;
		}
		else
		{
			$forma_pago_subsidio = $this->input->post('forma_pago_subsidio');
		}
		
		

		//$total_carrito = intval(preg_replace('/[^0-9]+/', '', $this->input->post('total_carrito'))); 
		if($tipo_venta==1){ $estado=1;}else {$estado=0;}
		//conseguimos el amximo de la factura primero 
		$maximo_factura= $this->Factura_model->maximo_factura();
		foreach($maximo_factura as $fila1)
					{
					 $num_factura=$fila1 -> num_factura+1; 
					}
		//recorremos los detalles_productos y cargamos los detalles
		$total_factura=0;

			for ($i=0;$i<intval($cantidad_item);$i++)    
			{
				//var_dump($codigo2);
				//actualizamos lçel stock
				$this->db->select('cantidad');
	            $this->db->from('producto');
	            $this->db->where('id_producto', intval($id_producto[$i]));
				$query1=$this->db->get();
				$row = $query1->row_array();
				$stock=$row['cantidad'] - Floatval($cantidad[$i]); 
				$dat = array(
	               'cantidad' => $stock,
	            );
	            $this->db->where('id_producto', intval($id_producto[$i]) );
				$this->db->update('producto', $dat);
				//cargamos el array para guardar todo
				$dato_detalle_factura  = array 
						(
						'id_detalle'=> '',
						'num_factura'=> $num_factura, 
						"cantidad" => Floatval($cantidad[$i]) ,
						"id_producto"=>intval($id_producto[$i]),
						"iva"=> intval($iva[$i]),
						"total_iva"=> intval($subtotal_iva[$i]),
						"precio"=> intval($precio[$i])
						
						);
				//var_dump($dato_detalle_factura);

				$total_factura=intval($total_factura) +  (intval($precio[$i] * Floatval($cantidad[$i]) )   );
				$this->Factura_model->adding_detalle_factura($dato_detalle_factura);
			}
			//CARGAMOS LA FACTURA
			$dato_factura  = array 
				(
				'id_factura'=> '',
				'num_factura'=> $num_factura, 
				"fecha" =>$add_fecha_expedicion,
				"id_alumno"=> $id_alumno,
				"tipo_venta"=> $tipo_venta,
				"importe"=> $total_factura,
				"estado"=> $estado,
				"forma_pago"=> $forma_pago,
				"forma_pago_subsidio"=> $forma_pago_subsidio,
				"monto_efectivo"=> $monto_efectivo,
				"monto_vuelto"=> $monto_vuelto,
				"observacion"=> $observacion_factura
				
				);
			$this->Factura_model->adding_dato_factura($dato_factura);

			

		if($tipo_venta==2)  //si es credito
		{
			if($this->input->post('n_cuota')!="" && intval($this->input->post('n_cuota'))>=1 && intval($this->input->post('n_cuota'))<51)
				{
					$n_cuota=$this->input->post('n_cuota');
				}
				else
				{
					$n_cuota=11;
				}
			if($this->input->post('vencimiento')!="" && intval($this->input->post('vencimiento'))<=31 && intval($this->input->post('vencimiento'))>0)
			{
				$vencimiento=$this->input->post('vencimiento');
			}
			else
			{
				$vencimiento=5;
			}
			
			$mes=date("m");
			$anho=date("Y");
			$aux=0;
			
		
			
			if ( $this->input->post('control_si_es_cuota')=="1") 
				{
				    $dato_credito  = array 
						(
						'id_credito'=> '',
						'id_alumno'=> $id_alumno,
						"num_factura" => $num_factura ,
						"importe"=>$total_factura,
						"fecha_venc"=>"",
						"pago"=> 0,
						"num_recibo"=> 0,
						"fecha_pago" =>"",
						"num_cuota"=> 1,
						"descripcion"=>"Factura Credito N° ".$num_factura ,
						);
						$this->Factura_model->adding_credito($dato_credito);
				    
				}
				else
				{
				    for($i=0; $i<$n_cuota; $i++)
        			{
        				if($mes==13 )
        				{
        					$mes=1;
        					$anho++;
        				}
        				else
        				{
        					if($mes<12)
        					{
        						$mes++;
        					}
        					else
        					{
        					$mes=1;
        					$anho++;
        					}
        				}
        
        					if ($aux==0 )
        					{
        						$cuota=$this->input->post('matricula');
        						$aux=1;
        						$n_cuota++;
        						$descripcion="Matricula ".$anho;
        					}
        					else
        					{
        						$cuota=$this->input->post('cuota');
        						$descripcion="Cuota N° ".($i);
        					}
        					
        				
        				$dato_credito  = array 
        						(
        						'id_credito'=> '',
        						'id_alumno'=> $id_alumno,
        						"num_factura" => $num_factura ,
        						"importe"=>$cuota,
        						"fecha_venc"=> $anho."/".$mes."/"."05",
        						"pago"=> 0,
        						"num_recibo"=> 0,
        						"fecha_pago" =>"",
        						"num_cuota"=> $i,
        						"descripcion"=> $descripcion,
        						);
        			$this->Factura_model->adding_credito($dato_credito);
        			}
        				    
				}
				
			
		}
		else  ///SI ES VENTA AL CONTADO
		{
			////AGREGAR A CAJA

				$query=$this->db->query("select id_factura from factura where num_factura=".$num_factura);
				if ($query->num_rows() > 0)  
		         {
		         	foreach ($query->result() as $row)
					 {
					 	$id_factura= $row -> id_factura;
					 }
		         }
				///insertamos en caja
				$data3 = array(
				'id_caja' =>'',
				'importe'=>$total_factura,
				'num_factura' => $num_factura,
				'id_compra_venta' => $id_factura,
				'debe_haber'=>1,
				'fecha'=>date("Y-m-d"),
				'cierre'=>'0',
				'descripcion'=>'Venta Mercaderia',
			
				);
				$this->db->insert('caja',$data3);
		}
		$this->db->trans_complete();
		if ($this->db->trans_status() === FALSE)
		{
		    $this->db->trans_rollback();
		}
		else
		{
		    $this->db->trans_commit();
		     if ($this->input->post('control_impresion')==1 )
		     {
		     	try {
		        	$connector = new Escpos\PrintConnectors\WindowsPrintConnector("EPSON TM-U220 Receipt");

		            $printer = new Escpos\Printer($connector);
		            //para centrar 1; derecha 2; izquierada 0
		                $printer->setJustification(1);
		                $printer->text("Bienvenidos");
		                $printer->text("\n"."DESPENSA SAMI" . "\n");
		                $printer->text("R.U.C.: Nº 4687727-7" . "\n");
		                $printer->text("Bº VILLA NUEVA" . "\n");
		                $printer->text("TRINIDAD-ITAPÚA" . "\n");
		                $printer->text("****No válido como comprobante***" . "\n");
		                #La fecha también
		                date_default_timezone_set("America/Asuncion");
		                $printer->text(date("d-m-Y H:i:s") . "\n");
		                $printer->text("----------------------------------------" . "\n");
		                $alumno_ticket = $this->Factura_model->alumno_ticket($num_factura);
		               /* foreach ($cliente_ticket as $cliente) 
		                {
		                	$printer->setJustification(0);
		                	$printer -> text( "ClIENTE: ".$cliente->cliente."\n");
		                	$printer -> text( "RUC: ".$cliente->cedula_ruc."\n");
		                	$printer -> text( "CONDICIÓN: ".$cliente->tipo_venta."\n");
		                	$printer -> text( "FORMA PAGO: ".$cliente->forma_pago."\n");
		                	break;
		                }
		                $printer->text("----------------------------------------" . "\n");
		                */
		                $printer->setJustification(0);
		                $printer -> text( $printer ->columnify("DESCRIPCION", "CODIGO", 10, 22, 1));
		               
		                 $printer->text( "CANTxUNIT"."                 "."SUBTOTAL"."\n");
		                
		                $printer->text("----------------------------------------"."\n");

		                $imprimir_ticket = $this->Factura_model->imprimir_ticket($num_factura);
		                $espacio="";
		                foreach ($imprimir_ticket as $producto) 
		                {
		                	$espacio_parcial = 20 - strlen($producto->cantidad_producto."x".$producto->precio_unitario);
		                	for ($i=0; $i < $espacio_parcial; $i++) 
		                	{ 
		                		$espacio = $espacio." ";
		                	}
		                	
		                    $printer->text( $producto->descripcion_producto."     ".$producto->codigo."\n");
		                    //$printer->text( "1234567890123456789"."-------------".$producto->subtotal."\n");
		                    $printer->text( round($producto->cantidad_producto,2)."x".$producto->precio_unitario.$espacio."       ".round($producto->subtotal,0)."\n");
		                     $espacio="";
		                }               

		                $printer->text("----------------------------------------"."\n");
		                $printer->setJustification(2);
		                
		                $total_subtotal = $this->Factura_model->total_subtotal($num_factura);
		                foreach($total_subtotal as $fila1)
	                    {
	                     $total_iva=$fila1 -> total_iva; 
	                     $total_factura=$fila1 -> total_factura; 
	                     break;
	                    }

	                   
		               
		                $printer->text("TOTAL: Gs. ".round($total_factura,0)."\n");
		                $printer->text("----------------------------------------"."\n");
		               //LE QUITE A PEDIDO DE MI CLIENTE VIP JAJAJ $printer->text("IVA: Gs. ".$total_iva."\n");
		                
		                $efectivo_vuelto = $this->Factura_model->efectivo_vuelto($num_factura);
	                    foreach($efectivo_vuelto as $fila2)
	                    {
	                    	$forma_pago=$fila2 -> forma_pago;
	                     	$monto_efectivo=$fila2 -> monto_efectivo; 
	                     	$monto_vuelto=$fila2 -> monto_vuelto; 
	                     break;
	                    }
	                    if($forma_pago <> 2)/// es en efectivo	                   
	                    {
	                    	$printer->text("ENTREGA CLIENTE: Gs. ".$monto_efectivo."\n");
		                	$printer->text("VUELTO: Gs. ".$monto_vuelto."\n");
	                    }

	                    $printer->setJustification(1);
		                $printer->text("***Muchas gracias por su compra***\n");



		                /*Alimentamos el papel 3 veces*/
		                $printer->feed(3);

		                /*
		                    Cortamos el papel. Si nuestra impresora
		                    no tiene soporte para ello, no generará
		                    ningún error
		                */
		                $printer->cut();

		                /*
		                    Por medio de la impresora mandamos un pulso.
		                    Esto es útil cuando la tenemos conectada
		                    por ejemplo a un cajón
		                */
		                $printer->pulse();

		                /*
		                    Para imprimir realmente, tenemos que "cerrar"
		                    la conexión con la impresora. Recuerda incluir esto al final de todos los archivos
		                */
		                $printer->close();
		        } catch (Exception $e) 
		        {
		            echo "No se pudo imprimir en esta impresora: " . $e -> getMessage() . "\n";
		        }

		     }
		     redirect('/Factura/add');

		}//aaa

		//////////////////////////////////////////////////////////
		////////////////////////////////////////////////////////////
			  	
		redirect('/Factura/add');	
	}
	/////////////////////////////////////////////////////////////////////////////////////////////7
	
	// funcion para dice edit pero es para ver detalles de la factutra
	public function ver_detalle()
	{
		
		$num_factura    = $this->uri->segment(3,0);	 
		$query = $this->db->query("  select * from factura inner join alumno on alumno.id_alumno=factura.id_alumno
			where factura.num_factura=".$num_factura."  ");
		
		$query2 = $this->db->query("  select * from credito 
			where num_factura=".$num_factura." and pago =0  ");	
			
		$datos=$query->row_array();
		if ($query2->num_rows() > 0)
			{
				$datos2=$query2->row_array();
				$importe_a_pagar= $datos2['importe'];
			}
			else
			{
				$importe_a_pagar=0;
			}
		

		$alumno=$datos['nombre']." ".$datos['apellido']." - CI/RUC. ".$datos['cedula'];

		$tipo_venta=$datos['tipo_venta'];
		$estado=$datos['estado'];
		$leyenda_estado="";
	
		if ($tipo_venta==2){$leyenda_tipo_venta=" Crédito";}
		if ($tipo_venta==1){$leyenda_tipo_venta=" Contado";}
		
		if ($estado==0){$leyenda_estado="Estado: A pagar <a  class='btn btn-danger' data-toggle='modal' href='#modal-id'> <span class='glyphicon lign-center'>Cobrar</span></a>";}
		else
		{
			$leyenda_estado="Estado: Pagado";
		}

		$query = $this->Factura_model->ver_detalle($num_factura);
		$consulta = $this->Factura_model->detalle_suma($num_factura);
			$data  = array 
			(
			'titulo'=> 'Facturacion',
			'factura_numero'=> $num_factura, 
			'leyenda_tipo_venta'=> $leyenda_tipo_venta, 
			'alumno'=> $alumno, 
			'estado'=> $leyenda_estado, 
			'num_factura'=> $num_factura, 
			'importe_total_credito'=> $importe_a_pagar, 
			"usuario" => $this->session->userdata('usuario'),
			"id_usuario"    => $this->session->userdata('id_usuario'),
			"formulario"=> $query,
			"formulario2"=> $consulta,
			"proveedor_lista" => $this->Proveedor_model->lista_proveedor()
			);		
			$this->parser->parse('Index/head.php', $data, FALSE);	
			$this->parser->parse('Index/menu.php',$data,FALSE); 	
			$this->parser->parse('Factura/factura_detalle_vista.php', $data);
			$this->load->view('Index/pie.php'); 
		
	}
	//////////////////////////////////////7
	// dar de baja o elminar
	function delete(){
		$id=$this->uri->segment(3,0);
 		$this->empleado_Model->delete($id);
		redirect('/empleado/empleado/index/');	
	}
	////////////////////////////////////////////77
	function delete_compra()
	{
		$id_compra=$this->uri->segment(3,0);
		$this->Factura_model->delete_compra($id_compra);
 		redirect('/Factura/inicio_compra');	
	}
	////////////////////////////////////////////77
	function delete_factura()
	{
		$num_factura=$this->uri->segment(3,0);
		$this->Factura_model->delete_factura($num_factura);
 		redirect('/Factura/index');	
	}

////////////////////////////////////////////////////////////////////////
	function devolucion_compra()
	{
		$id_compra=$this->uri->segment(3,0);
		$query=$this->db->query("select * from compra where id_compra=".$id_compra);
		if ($query->num_rows() > 0)  
         {
         	 foreach ($query->result() as $row)
			 {
			 	$data3 = array(
				'id_caja' =>'',
				'importe'=>$row->importe,
				'num_factura' =>$row->num_factura,
				'id_compra_venta' => $row->id_compra,
				'debe_haber'=>1,
				'fecha'=>date("Y-m-d"),
				'cierre'=>'0',
				'descripcion'=>'Devolucion de Compra',
			
				);
				$this->db->insert('caja',$data3);


			 }

         }
		$this->Factura_model->delete_compra($id_compra);
 		redirect('/Factura/inicio_compra');	
	}
	////////////////////////
	function anulacion_factura()
	{
		$num_factura=$this->uri->segment(3,0);
		$query=$this->db->query("select * from factura where num_factura=".$num_factura);

		if ($query->num_rows() > 0)  
         {
         	 foreach ($query->result() as $row)
			 {
			 	$data3 = array(
				'id_caja' =>'',
				'importe'=>$row->importe,
				'num_factura' =>$num_factura,
				'id_compra_venta' => $row->id_factura,
				'debe_haber'=>2,
				'fecha'=>date("Y-m-d"),
				'cierre'=>'0',
				'descripcion'=>'Anulacion de Factura Venta',
			
				);
				$this->db->insert('caja',$data3);


			 }

         }
		$this->Factura_model->anulacion_factura($num_factura);
 		redirect('/Factura/index');	
	}
	////////////////////////////////////////////////////////////////////////


/////////////////////////buscado filtro///////////////
	public function buscador_cedula()
	{
		$cedula=$this->uri->segment(3,0);

				$consulta = 'SELECT  *  FROM alumno WHERE cedula ="'.$cedula.'"';
				$query = $this->db->query($consulta);
								
				if ($query->num_rows() > 0) 
				{  $row = $query->row(); 
					$data = array 
					(			
					'nombre'=> $row->nombre,
					'apellido'=> $row->apellido,
					'cedula'=> $row->cedula,
					'id_alumno'=> $row->id_alumno,
					
					);
					$this->parser->parse('Factura/filtro.php',$data);
				} 
				
						

	 }
	 
 ///////////////////////////////////////////////////////////////
 /////////////////////////buscador2 filtro///////////////
	public function buscador2()
	{
		$codigo=$this->input->post('codigo'); 
		//$consulta = "SELECT  * FROM producto WHERE codigo =".$codigo." ";
		$consulta = "SELECT  * FROM producto WHERE codigo =".$codigo." ";
		$query = $this->db->query($consulta);										
		if ($query->num_rows() > 0) 
		{  
			$array[] = $query->row_array();
			echo json_encode($array);
		} 
		

	 }
	 //////////////////////////////////////
	public function buscador3()
	{
		$id=$this->input->post('codigo'); 
		
		$consulta = "SELECT id_producto, marca.marca as marca, modelo.modelo as modelo, precio_co FROM producto 
		inner  join marca on marca.id_marca=producto.id_marca
		inner join modelo on modelo.id_modelo=producto.id_modelo
		 WHERE id_producto =".$id." ";
		$query = $this->db->query($consulta);
		$row = $query->row();
		$id_producto= $row->id_producto;
		$data = array 
					(				
						'id_producto'=> $row->id_producto,
						'marca_modelo'=> $row->marca."-".$row->modelo,
						'precio'=> "",
						'ERROR'=> ''
					);

					$this->parser->parse('Factura/filtro3.php',$data);
	 }
		
 ///////////////////////////////////////////////////////////////
	public function buscadornombre()
	{
	 $filter=$this->input->post('nombre'); 
	 
	 $consulta = "SELECT  CONCAT(nombre,' ',apellido) as nombre,direccion,cedula,id_alumno FROM alumno WHERE nombre LIKE '%".$filter."' OR apellido LIKE '%".$filter."' ";
			
			$query = $this->db->query($consulta);										
								
				if ($query->num_rows() > 0) 
				{  $row = $query->row(); 
					$data = array 
					(
					
					'alumno'=> $row->cedula."-".$row->nombre,
					'direccion'=> $row->direccion,
					'id_alumno'=> $row->id_alumno,

					'ERROR'=> ''
					);
					$this->parser->parse('factura/filtro.php',$data);
				} 
				else
				{
					$data = array
					(
						'alumno'=> "",
						'direccion'=> "",
						'id_alumno'=> "",
						'ERROR'=> 'No encontrado'
					);
					$this->parser->parse('factura/filtro.php',$data);
				 
				}		
	}
 /////////////////////////////////////////////////////////////
	function add_carro()
	{
	// Set array for send data.
		$insert_data = array(
		'id' => $this->input->post('codigo'),
		'name' => $this->input->post('descripcion'),
		'price' => $this->input->post('precio_venta'),
		'qty' => 1,
		);

		// This function add items into cart.
		$this->cart->insert($insert_data);
		// This will show insert data in cart.
		redirect('Factura/add');
	}
	 ////////////////////////////////////////////
	function eliminar($rowid) 
	{
		// Check rowid value.
		if ($rowid==="all"){
		// Destroy data which store in session.
		$this->cart->destroy();
		}else{
		// Destroy selected rowid in session.
		$data = array(
		'rowid' => $rowid,
		'qty' => 0
		);
		// Update cart data, after cancel.
		$this->cart->update($data);
		}

		// This will show cancel data in cart.
		redirect('Factura/add');
	}

	function actualizar_carro()
	{

		// Recieve post values,calcute them and update
		$cart_info = $_POST['cart'] ;
		foreach( $cart_info as $id => $cart)
		{
			$rowid = $cart['rowid'];
			$price = $cart['price'];
			$amount = $price * $cart['qty'];
			$qty = $cart['qty'];

			$data = array(
			'rowid' => $rowid,
			'price' => $price,
			'amount' => $amount,
			'qty' => $qty,
			
			);

			$this->cart->update($data);
		}
		
		redirect('Factura/add');
	}
	//////////////////////////////////////////

	function add_alumno()
	{
		$data = array 
		(
			'titulo'=> 'Facturacion',				
			'ci'=> $this->Factura_model->datos_alumno(),
			'alumno'=> "",
			'direccion'=> "",
			'codigo'=> $this->Factura_model->datos_producto(),
			'num_factura'=> $this->Factura_model->maximo_factura(),
			"usuario" => $this->session->userdata('usuario'),
			"id_usuario"    => $this->session->userdata('id_usuario'),
			"proveedor_lista" => $this->Proveedor_model->lista_proveedor()
		);	
		$this->parser->parse('Index/head.php', $data, FALSE);	
		$this->parser->parse('Index/menu.php',$data,FALSE); 
		$this->parser->parse('factura/factura_add_alumno.php', $data);
		$this->load->view('Index/pie.php');

		
	}


	public function save_factura()
	{
		date_default_timezone_set("America/Asuncion");
		$mayor =$this->Factura_model->maximo_factura();
		foreach($mayor as $fila1)
			{
			 $mayor1=intval(  ($fila1 -> num_factura+1) ); 
			}
		$query =$this->db->query("select id_alumno from alumno where cedula='".$this->input->post('filter')."'");
		$row = $query->row();
		$id_alumno= $row->id_alumno;
		if ($this->input->post('condicion')==1)
		{
			$estado=1;
		}
		else
		{
			$estado=0;
		}

		$dato_factura = array(
		'id_factura' => "",
		'num_factura' => $mayor1,
		'id_alumno' => $id_alumno,
		'fecha' => date("Y-m-d"),
		'tipo_venta' => $this->input->post('condicion'),
		'estado' => $estado,
		'importe' => $this->cart->total(),

		);
		$this->Factura_model->adding_dato_factura($dato_factura);

		if ($cart = $this->cart->contents()):
		foreach ($cart as $item):
		$detalle_factura = array(
		'id_detalle' => "",
		'cantidad' => $item['qty'],
		'producto' => $item['id'],
		'precio' => $item['price'],
		'iva' => 0,
		'tipo_iva' => "",
		'num_factura' => $mayor1,
		);
		$this->Factura_model->adding_detalle_factura($detalle_factura);
		endforeach;
		endif;
		if ($this->input->post('condicion')==2)
		{
			$dato_credito = array(
			'id_credito' => "",
			'id_alumno' => $id_alumno,
			'num_factura' => $mayor1,
			'importe' => $this->cart->total(),
			'pago' => 0,
			'num_recibo' => 0,
			'fecha_pago' => null,
			'num_cuota' => 1,

			);
			$this->Factura_model->adding_credito($dato_credito);
		}

		$this->cart->destroy();

		redirect('/Factura/');

	
	}

	////////////////////////////////////////////////INICIO PAGAR CREDITO COMPRA
	public function pagar_credito_compra()
	{
		$id_compra=$this->uri->segment(3,0);
		$monto_credito_compra=$this->input->post('monto_credito_compra'.$id_compra);

		$this->db->where('id_compra',$id_compra);
		$consulta = $this->db->get('compra');
		$fila = $consulta->row_array();
		$num_factura= $fila['num_factura'];


		$data = array(
			'estado' => "1"
		);
		$this->db->where('id_compra',$id_compra);
		$this->db->update('compra',$data);

		$data3 = array(
				'id_caja' =>'',
				'importe'=>$monto_credito_compra,
				'num_factura' => $num_factura,
				'id_compra_venta' => $id_compra,
				'debe_haber'=>2,
				'fecha'=>date("Y-m-d"),
				'cierre'=>'0',
				'descripcion'=>'Compra Mercaderia a Crédito',
			
				);
				$this->db->insert('caja',$data3);
	redirect('/Factura/inicio_compra');	

	}

	////////////////////////////////////////////////INICIO cobrqr factura credito
	public function cobrar_credito_factura()
	{
		$num_factura=$this->uri->segment(3,0);
		$monto_credito_factura=$this->input->post('monto_credito_factura'.$num_factura);

		$this->db->where('num_factura',$num_factura);
		$consulta = $this->db->get('factura');
		$fila = $consulta->row_array();
		$id_factura= $fila['id_factura'];


		$data = array(
			'estado' => "1"
		);
		$data2 = array(
			'pago' => "1"
		);
		$this->db->where('num_factura',$num_factura);
		$this->db->update('factura',$data);
		$this->db->where('num_factura',$num_factura);
		$this->db->update('credito',$data2);

		$data3 = array(
				'id_caja' =>'',
				'importe'=>$monto_credito_factura,
				'num_factura' => $num_factura,
				'id_compra_venta' => $id_factura,
				'debe_haber'=>1,
				'fecha'=>date("Y-m-d"),
				'cierre'=>'0',
				'descripcion'=>'Pago Mercaderia a Crédito',
			
				);
				$this->db->insert('caja',$data3);
	redirect('/Factura');	

	}

	public function edit_factura()
	{
		$num_factura=$this->uri->segment(3,0);
		$cedula=$this->input->post('alumno_edit');
		$tipo_venta=$this->input->post('tipo_venta_edit');
		$estado=$this->input->post('estado_edit');
		$forma_pago=$this->input->post('forma_pago_edit');
		$fecha=$this->input->post('fecha_edit');
		$observacion=$this->input->post('observacion_factura');
		
		$query=$this->db->query('select id_alumno from alumno where cedula="'.$cedula.'"');
				if ($query->num_rows() > 0)  
		         {
		         	foreach ($query->result() as $row)
					 {
					 	$id_alumno= $row -> id_alumno;
					 }
		         }
		


		if ($this->input->post('fecha_edit')!="")
		{
			$fecha=$this->input->post('fecha_edit');
		}
		else
		{
			$fecha= date("Y-m-d", strtotime($this->input->post('fecha')));
		}
			

		$data3 = array(
				'fecha' =>$fecha,
				'id_alumno'=>$id_alumno,
				'tipo_venta' => $tipo_venta,
				'estado'=>$estado,
				'forma_pago'=>$forma_pago,
				'observacion'=>$observacion,
				
			
				);
		$this->db->where('num_factura',$num_factura );
		$this->db->update('factura',$data3);
		//avergiguamos el importe
		$query2=$this->db->query('select importe from factura where num_factura='.$num_factura);
				if ($query2->num_rows() > 0)  
		         {
		         	foreach ($query2->result() as $row2)
					 {
					 	$importe= $row2 -> importe;
					 }
		         }


		if ($tipo_venta==2)
		{
			if($estado==1)
			{
				$data4 = array(
				'id_credito' =>"",
				'id_alumno'=>$alumno,
				'num_factura' => $num_factura,
				'importe' => $importe,
				'fecha_venc' => "0000-00-00",
				'pago'=>1,
				'num_recibo'=>null,
				'fecha_pago'=>$fecha,
				'num_cuota'=>1,
				);
				

			}
			else
			{
				$data4 = array(
				'id_credito' =>"",
				'id_alumno'=>$id_alumno,
				'num_factura' => $num_factura,
				'importe' => $importe,
				'fecha_venc' => "0000-00-00",
				'pago'=>0,
				'num_recibo'=>null,
				'fecha_pago'=>$fecha,
				'num_cuota'=>1
				);
			}
			$query2=$this->db->query('select * from credito where num_factura='.$num_factura);
				if ($query2->num_rows() <= 0)  
		         {
		         		$this->db->insert('credito',$data4);
		         }
		
			redirect('/Factura/index');
			

		}
		else
		{
			redirect('/Factura/index');	
		}
	

	}
	
	
	public function edit_credito()
	{
	    
		$id_credito=$this->uri->segment(3,0);
		
		$descripcion=$this->input->post('edit_descripcion');
		$importe=$this->input->post('edit_importe');
		$num_recibo=$this->input->post('edit_num_recibo');
		$fecha_pago=$this->input->post('edit_fecha_pago');
		$pago=$this->input->get_post('edit_pago');
		$observacion=$this->input->post('edit_obser');
		if ($pago=="Pagado")
		{
		    $pago=1;
		}
		else
		{
		    $pago=0;
		}
		
		$data3 = array(
				'descripcion' =>$descripcion,
				'importe'=>$importe,
				'num_recibo' => $num_recibo,
				'fecha_pago'=>$fecha_pago,
				'pago'=>$pago,		
				'observacion'=>$observacion,
							
				);
		$this->db->where('id_credito',$id_credito );
		$this->db->update('credito',$data3);
		redirect('/Factura/index');		

	}

	public function edit_compra()
	{
		$id_compra=$this->uri->segment(3,0);
		$id_proveedor=$this->input->post('proveedor_edit');
		$tipo_compra=$this->input->post('tipo_compra_edit');
		$estado=$this->input->post('estado_edit');
		if ($this->input->post('fecha_compra_edit')!="")
		{
			$fecha_compra=$this->input->post('fecha_compra_edit');
		}
		else
		{
			$fecha_compra= date("Y-m-d", strtotime($this->input->post('fecha_edit')));
			
			
		}		
		$num_factura=$this->input->post('num_factura_edit');
		
		$data3 = array(
				'num_factura' =>$num_factura,
				'id_proveedor'=>$id_proveedor,
				'fecha_compra' => $fecha_compra,
				'tipo_compra'=>$tipo_compra,
				'estado'=>$estado		
							
				);
		$this->db->where('id_compra',$id_compra );
		$this->db->update('compra',$data3);


	redirect('/Factura/inicio_compra');	

	}



	////////////////////////////////////////////////// FIN PAGAR CREDITO COMPRA

	public function busqueda_producto()
	{
		//$descripcion=$this->input->post('buscar_producto_descripcion');
		$descripcion=utf8_decode($this->uri->segment(3,0));
		if($descripcion=="%C3%91")
		{
			$descripcion="Ñ";
		}

	
		$this->db->select("*");  
        $this->db->from("producto");
        $this->db->like("descripcion", $descripcion);  
        $this->db->limit(15);

		 $query = $this->db->get();
		if ($query->num_rows() > 0) 
			{  
				$array = $query->result_array();
				echo json_encode($array);
			} 
	 }




	/////////////////////////////////////////////////cINICIO COMPRA DE MERCADERAIA
	public function inicio_compra()
	{
		$data = array();
        $limit_per_page = 20;
        $start_index = ($this->uri->segment(4)) ? $this->uri->segment(4) : 0;
        $total_records =$this->Factura_model->get_total_compra();

        if ($total_records > 0) 
        {
            $data["ENCABEZADO"] ='Listado de Compra';
           
            $data["usuario"] = $this->session->userdata('usuario');
              $data["id_usuario"] = $this->session->userdata('id_usuario');
            $data["proveedor_lista"] =$this->Proveedor_model->lista_proveedor();

            $data["results"] = $this->Factura_model->get_factura_compra($limit_per_page, $start_index );
             
            $config['base_url'] = base_url() . 'index.php/Factura/inicio_compra';
            $config['total_rows'] = $total_records;
            $config['per_page'] = $limit_per_page;
            $config["uri_segment"] = 4;
            $config['full_tag_open'] = '<ul class="pagination">';
            $config['full_tag_close'] = '</ul>'; 
            $config['first_link'] = 'First';
            $config['last_link'] = 'Last';
            $config['first_tag_open'] = '<li>';        
	        $config['first_tag_close'] = '</li>';        
	        $config['prev_link'] = '&laquo';        
	        $config['prev_tag_open'] = '<li class="prev">';        
	        $config['prev_tag_close'] = '</li>';        
	        $config['next_link'] = '&raquo';        
	        $config['next_tag_open'] = '<li>';        
	        $config['next_tag_close'] = '</li>';        
	        $config['last_tag_open'] = '<li>';        
	        $config['last_tag_close'] = '</li>';        
	        $config['cur_tag_open'] = '<li class="active"><a href="#">';        
	        $config['cur_tag_close'] = '</a></li>';        
	        $config['num_tag_open'] = '<li>';        
	        $config['num_tag_close'] = '</li>';
            
            $this->pagination->initialize($config);
             
            // build paging links
            $data["links"] = $this->pagination->create_links();
        }




		
		$this->parser->parse('Index/head.php', $data, FALSE);	
		$this->parser->parse('Index/menu.php',$data );	
		
        $this->parser->parse('Factura/factura_compra_vista',$data,false);
        $this->load->view('Index/pie.php'); 
	}




//////////////////////////////////////////////////FIN COMPRA DE MERCADERAI


	


      /////////////////////////////////////////////////////
      function columnify($leftCol, $rightCol, $leftWidth, $rightWidth, $space = 4)
				{
				    $leftWrapped = wordwrap($leftCol, $leftWidth, "\n", true);
				    $rightWrapped = wordwrap($rightCol, $rightWidth, "\n", true);

				    $leftLines = explode("\n", $leftWrapped);
				    $rightLines = explode("\n", $rightWrapped);
				    $allLines = array();
				    for ($i = 0; $i < max(count($leftLines), count($rightLines)); $i ++) {
				        $leftPart = str_pad(isset($leftLines[$i]) ? $leftLines[$i] : "", $leftWidth, " ");
				        $rightPart = str_pad(isset($rightLines[$i]) ? $rightLines[$i] : "", $rightWidth, " ");
				        $allLines[] = $leftPart . str_repeat(" ", $space) . $rightPart;
				    }
				    return implode($allLines, "\n") . "\n";
				}

      ////////////////////////////////////////////////////
	 function reimprimir()
	{
		$num_factura=utf8_decode($this->uri->segment(3,0));

		try {
		        	$connector = new Escpos\PrintConnectors\WindowsPrintConnector("EPSON TM-U220 Receipt");

		            $printer = new Escpos\Printer($connector);
		            //para centrar 1; derecha 2; izquierada 0
		                $printer->setJustification(1);
		                $printer->text("Bienvenidos");
		                $printer->text("\n"."DESPENSA SAMI" . "\n");
		                $printer->text("R.U.C.: Nº 4687727-7" . "\n");
		                $printer->text("Bº VILLA NUEVA" . "\n");
		                $printer->text("TRINIDAD-ITAPÚA" . "\n");
		                $printer->text("****No válido como comprobante***" . "\n");
		                #La fecha también
		                date_default_timezone_set("America/Asuncion");
		                $printer->text(date("d-m-Y H:i:s") . "\n");
		                $printer->text("----------------------------------------" . "\n");
		                $alumno_ticket = $this->Factura_model->alumno_ticket($num_factura);
		              

		                $printer->setJustification(0);
		                $printer -> text( $printer ->columnify("DESCRIPCION", "CODIGO", 10, 22, 1));
		               
		                 $printer->text( "CANTxUNIT"."                 "."SUBTOTAL"."\n");
		                
		                $printer->text("----------------------------------------"."\n");

		                $imprimir_ticket = $this->Factura_model->imprimir_ticket($num_factura);
		                $espacio="";
		                foreach ($imprimir_ticket as $producto) 
		                {
		                	$espacio_parcial = 20 - strlen($producto->cantidad_producto."x".$producto->precio_unitario);
		                	for ($i=0; $i < $espacio_parcial; $i++) 
		                	{ 
		                		$espacio = $espacio." ";
		                	}
		                	
		                    $printer->text( $producto->descripcion_producto."     ".$producto->codigo."\n");
		                    //$printer->text( "1234567890123456789"."-------------".$producto->subtotal."\n");
		                    $printer->text( round($producto->cantidad_producto,2)."x".$producto->precio_unitario.$espacio."       ".round($producto->subtotal,0)."\n");
		                     $espacio="";
		                }               

		                $printer->text("----------------------------------------"."\n");
		                $printer->setJustification(2);
		                
		                $total_subtotal = $this->Factura_model->total_subtotal($num_factura);
		                foreach($total_subtotal as $fila1)
	                    {
	                     $total_iva=$fila1 -> total_iva; 
	                     $total_factura=$fila1 -> total_factura; 
	                     break;
	                    }

	                   
		               
		                $printer->text("TOTAL: Gs. ".round($total_factura,0)."\n");
		                $printer->text("----------------------------------------"."\n");
		               //LE QUITE A PEDIDO DE MI CLIENTE VIP JAJAJ $printer->text("IVA: Gs. ".$total_iva."\n");
		                
		                $efectivo_vuelto = $this->Factura_model->efectivo_vuelto($num_factura);
	                    foreach($efectivo_vuelto as $fila2)
	                    {
	                    	$forma_pago=$fila2 -> forma_pago;
	                     	$monto_efectivo=$fila2 -> monto_efectivo; 
	                     	$monto_vuelto=$fila2 -> monto_vuelto; 
	                     break;
	                    }
	                    if($forma_pago <> 2)/// es en efectivo	                   
	                    {
	                    	$printer->text("ENTREGA CLIENTE: Gs. ".$monto_efectivo."\n");
		                	$printer->text("VUELTO: Gs. ".$monto_vuelto."\n");
	                    }

	                    $printer->setJustification(1);
		                $printer->text("***Muchas gracias por su compra***\n");



		                /*Alimentamos el papel 3 veces*/
		                $printer->feed(3);

		                /*
		                    Cortamos el papel. Si nuestra impresora
		                    no tiene soporte para ello, no generará
		                    ningún error
		                */
		                $printer->cut();

		                /*
		                    Por medio de la impresora mandamos un pulso.
		                    Esto es útil cuando la tenemos conectada
		                    por ejemplo a un cajón
		                */
		                $printer->pulse();

		                /*
		                    Para imprimir realmente, tenemos que "cerrar"
		                    la conexión con la impresora. Recuerda incluir esto al final de todos los archivos
		                */
		                $printer->close();
		        } catch (Exception $e) 
		        {
		            echo "No se pudo imprimir en esta impresora: " . $e -> getMessage() . "\n";
		        }

		    

		     


		      redirect('/Factura/index');

		        


    

	}



    

 }

//////////////////////////////////////////////////FIN COMPRA DE MERCADERAI




