<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Matricula extends CI_Controller {

	public function __construct()
	{
		parent::__construct();
				
		$this->load->model("Matricula_model");
    $this->load->model("Alumno_model");
    $this->load->model("Carrera_model");

		$this->load->library('form_validation');

		if(!$this->session->userdata('id_usuario'))
		{
		redirect('/Login');
		} 

	}
	
	public function index()
	{
	    $data = array();
	    if ($this->input->get_post('anho_matricula_buscar',true)!="")
	    {
	        $anho= $this->input->get_post('anho_matricula_buscar',true);
	    }else {$anho=date("Y");  }
	    
	    
        $limit_per_page = 10;
        $start_index = ($this->uri->segment(3)) ? $this->uri->segment(3) : 0;

        $total_records =$this->Matricula_model->get_all_data($anho);  

        $data["ENCABEZADO"] ='Matriculaciones';
        $data["usuario"] = $this->session->userdata('usuario');
        $data["lista_alumno"] =$this->Alumno_model->lista_alumno();
        $data["lista_estado_matricula"] =$this->Matricula_model->lista_estado_matricula();
        $data["lista_carrera"] =$this->Carrera_model->lista_carrera();
        $data["lista_filial"] =$this->Matricula_model->filial();

        $data["id_usuario"] = $this->session->userdata('id_usuario');
        $data["nombre"] = $this->session->userdata('nombre');
        $data["rol"] = $this->session->userdata('rol');
        $data["total_records"] =  $total_records;
        $data["anho_matricula"]=$anho;
        $data["results"] = $this->Matricula_model->get_matricula(  $limit_per_page, $start_index, $anho);
            
            $config['base_url'] = base_url() . 'index.php/Matricula/index';
            $config['total_rows'] = $total_records;
            $config['per_page'] = $limit_per_page;
            $config["uri_segment"] = 3;
            $config['full_tag_open'] = '<ul class="pagination">';
            $config['full_tag_close'] = '</ul>'; 
            $config['first_link'] = 'Primero';
            $config['last_link'] = 'Último';
            $config['first_tag_open'] = '<li>';        
            $config['first_tag_close'] = '</li>';        
            $config['prev_link'] = '&laquo';        
            $config['prev_tag_open'] = '<li class="prev">';        
            $config['prev_tag_close'] = '</li>';        
            $config['next_link'] = '&raquo';        
            $config['next_tag_open'] = '<li>';        
            $config['next_tag_close'] = '</li>';        
            $config['last_tag_open'] = '<li>';        
            $config['last_tag_close'] = '</li>';        
            $config['cur_tag_open'] = '<li class="active"><a href="#">';        
            $config['cur_tag_close'] = '</a></li>';        
            $config['num_tag_open'] = '<li>';        
            $config['num_tag_close'] = '</li>';
            
            $this->pagination->initialize($config);  
            $data["links"] = $this->pagination->create_links();
          
      $this->parser->parse('Index/head.php',$data, FALSE);  
      $this->parser->parse('Index/menu.php',$data, FALSE);   
      $this->parser->parse('Matricula/matricula_vista.php',$data, FALSE); 
      $this->load->view('Index/pie.php');  
       
       
	}

    
 ///////////////////////////////////////////////////////////////

	
	public function adding ()
	{
	    $id_alumno=$this->input->get_post('alumno',true);
	    $cantidad_registro= count($id_alumno); 
	    
	    for ($i=0; $i < $cantidad_registro; $i++)    
	    {
	        $this->db->from("matricula"); 
    	    $this->db->where('id_alumno',$id_alumno[$i] );
    	    $this->db->where('anho',$this->input->get_post('anho',true) );
    	    $query = $this->db->get();
    	    if ($query->num_rows() <= 0)  
                 {
                     $data = array
            	    (
            	        'id_matricula'=> '',
            	        "id_alumno" => intval($id_alumno[$i]),
            	        "fecha_matricula" => $this->input->get_post('fecha_matricula',true),
            	        "anho" => $this->input->get_post('anho',true),
            	        "estado_matricula" => $this->input->get_post('estado_matricula',true),
            	        "tipo_matricula" => 1
                    );	
            	 	$this->Matricula_model->add_matricula($data);
            	    $ultima_matricula =$this->Matricula_model->ultima_matricula();
            	    if (isset($ultima_matricula))
            	    {
                        $ultima_matricula=intval($ultima_matricula -> id_matricula); 
            	    }
            	     $cantidad_item = $this->input->post('cantidad_item');
            	     $id_carrera = $this->input->get_post('id_carrera',true);
            	     $curso = $this->input->get_post('curso',true);
            	     $id_institucion = $this->input->get_post('id_institucion',true);
            	     $id_filial = $this->input->get_post('id_filial',true);
            	     
            	     $id_carrera_length = count($id_carrera);
            	     for ($i=0;$i<intval($id_carrera_length);$i++)
            	     {
            	         $data2 = array 
            	         (
                              'id_inscripcion'=> '',
                              "id_matricula" =>  $ultima_matricula,
                              "id_carrera" => intval($id_carrera[$i]),
                              "curso" =>  intval($curso[$i]),
                              "id_institucion" => intval($id_institucion[$i]),
                              "id_filial" => intval($id_institucion[$i]),
                            ); 
                            $this->Matricula_model->add_inscripcion($data2);  
                        }
            	    
                 }
	  }
      
    redirect('/Matricula');
	 }

	public function edit_carrera()
	{
		$id_carrera=$this->uri->segment(4,0);
		
		$data = array 
				(
					"id_tipo_carrera" => $this->input->get_post('id_tipo_carrera',true),
          "codigo_carrera" => $this->input->get_post('codigo_carrera',true),
          "carrera" => $this->input->get_post('carrera',true),
          "duracion" => $this->input->get_post('duracion',true),
           "tipo_duracion" => $this->input->get_post('tipo_duracion',true),
          "regimen" => $this->input->get_post('regimen',true),
          "observacion_regimen" => $this->input->get_post('observacion_regimen',true),
          "modalidad" => $this->input->get_post('modalidad',true),
          "nivel" => $this->input->get_post('nivel',true),
          "observacion" => $this->input->get_post('observacion',true),
          "fecha_habilitacion" => $this->input->get_post('fecha_habilitacion',true),
          "estado" => $this->input->get_post('estado',true),
          "resolucion" => $this->input->get_post('resolucion',true) 
				);			
			$this->Carrera_model->save_edit($id_carrera,$data);
			redirect('/Carrera/carrera');	
	}


	// dar de baja o elminar
	function eliminar_matricula()
	{
		
		$id_matricula=$this->uri->segment(3,0);
		$this->Matricula_model->eliminar_matricula($id_matricula);
        
        redirect('/Matricula');
	}

	 
}
