<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Paciente extends CI_Controller {
	public function __construct()
	{
		parent::__construct();
		// Cargamos las librerias, model, helper;
		$this->load->library('form_validation');
		$this->load->model("Paciente_Model");

		if(!$this->session->userdata('id_usuario'))
		{
		redirect('/Login/login/');
		} 

	}

	public	function index()
	{
		
		
		$data = array //arreglo para mandar datos a la vista
			(
					'titulo'=> 'Administrar Pacientes',//mi titulo 
					'formulario' =>  $this->Paciente_Model->getPaciente(),
					"usuario" => $this->session->userdata('usuario'),
					"permiso" => $this->session->userdata('permiso'),
					"nombre" => $this->session->userdata('nombre'),
					"denominacion" => $this->session->userdata('denominacion'),
					"id_permiso" => $this->session->userdata('id_permiso'),

			);
			
			$this->parser->parse('Index/head.php',$data, FALSE);	// carga todos las url de estilo i js home	
			$this->parser->parse('Index/menu.php',$data, FALSE); // esta seria la barra de navegacion horizontal
	 	 	$this->parser->parse('Paciente/paciente_lista.php',$data, FALSE);
			
			$this->load->view('Index/pie.php'); // pie con los js
	}
	public function add()
	{
		$data = array //arreglo para mandar datos a la vista
			(

					'titulo'=> 'Agregar Datos del Paciente',//mi titulo 
					"usuario" => $this->session->userdata('usuario'),
					"departamento1" => $this->Paciente_Model->departamento(),
					"permiso" => $this->session->userdata('permiso'),
					"nombre" => $this->session->userdata('nombre'),
					"id_permiso" => $this->session->userdata('id_permiso'),
					"denominacion" => $this->session->userdata('denominacion'),
					
					

			);
			//redirecionamos a la vista o llamamos a la vista index
			
			$this->parser->parse('Index/head.php',$data, FALSE);	// carga todos las url de estilo i js home
			$this->parser->parse('Index/menu.php',$data, FALSE); // esta seria la barra de navegacion horizontal
			$this->parser->parse('Paciente/paciente_add.php',$data, FALSE); // este seria todo el contenido central
			$this->load->view('Index/pie.php'); // pie con los js
	}
	public function adding (){		
		$cedula = $this->input->post('cedula');
		$nombre = $this->input->post('nombre');
		$apellido = $this->input->post('apellido');
		$fecha_nac = $this->input->post('fecha_nac');
		$id_barrio = $this->input->post('barrio');
		$id_departamento = $this->input->post('departamento');
		$id_distrito = $this->input->post('distrito');
		$telefono = $this->input->post('telefono');
		$ficha = $this->input->post('ficha');
		$direccion_ficha = $this->input->post('direccion_ficha');
		$etnia = $this->input->post('etnia');
		$nacionalidad = $this->input->post('nacionalidad');
		$seguro = $this->input->post('seguro');

		$this->Paciente_Model->add_paciente($cedula,$nombre,$apellido,$fecha_nac,$id_barrio,$id_distrito,$id_departamento,$telefono,$ficha,$direccion_ficha,$etnia,$nacionalidad,$seguro);		
		redirect('/Paciente/paciente/index/');

		
	}
	public function edit(){

		$id    = $this->uri->segment(4,0);	// OCTENGO EL ID QUE LE ENVIO A TRAVES DE LA VISTA I LE PASO AL MODELO	 
		$query = $this->Paciente_Model->edit($id);// OCTENGO LA CONSULTA QUE ESTA EN EL MODELO EN  FUNCTION EDIT 
		// validamos si nuestra consulta es distinto a false mostramos la vista de editar con los datos
		if ($query != false){
		$data = array //arreglo para mandar datos a la vista
			(
					
					'titulo'=> 'Modificar datos',//mi titulo 
					"usuario" => $this->session->userdata('usuario'),
					'formulario'=> $query,
					"departamento1" => $this->Paciente_Model->departamento(),
					"permiso" => $this->session->userdata('permiso'),
					"nombre" => $this->session->userdata('nombre'),
					"denominacion" => $this->session->userdata('denominacion'),
			);
			$this->parser->parse('Index/head.php',$data, FALSE);	// carga todos las url de estilo i js home	
			$this->parser->parse('Index/menu.php',$data, FALSE); // esta seria la barra de navegacion horizontal
			$this->parser->parse('Paciente/paciente_edit.php',$data, FALSE); // este seria todo el contenido central
			
			$this->load->view('Index/pie.php'); // pie con los js
		}else{
			return false;
		}
		

	

	}
	// guardar lo editado
	public function save_edit(){
		
						$id = $this->input->post('id_paciente');
						$data = array(
							'cedula' => $this->input->post('cedula'),
							'nombre' => $this->input->post('nombre'),
							'apellido' => $this->input->post('apellido'),
							'fecha_nac' => $this->input->post('fecha_nac'),
							'id_direccion' => $this->input->post('departamento_edit').$this->input->post('distrito').$this->input->post('barrio'),
							'id_barrio' => $this->input->post('barrio'),
							'id_distrito' => $this->input->post('distrito'),
							'id_departamento' => $this->input->post('departamento_edit'),
							'telefono' => $this->input->post('telefono'),
							'ficha' => $this->input->post('ficha'),
							'direccion_ficha' => $this->input->post('direccion_ficha'),
							'etnia' => $this->input->post('etnia'),
							'nacionalidad' => $this->input->post('nacionalidad'),
							'seguro' => $this->input->post('seguro'),


						);

						$data2 = array(
							'id_paciente' => $this->input->post('cedula'),
						);
						$ci_anterior = $this->input->post('ci_anterior');
						$this->Paciente_Model->save_edit($id,$data,$ci_anterior,$data2);
						redirect('/Paciente/paciente/index/');
			
	}

	// dar de baja o elminar
	public function delete(){
		$id=$this->uri->segment(4,0);
 		$this->Paciente_Model->delete($id);
		redirect('/Paciente/paciente/index/');	
	}
	////////////////////
	

	public function llena_departamento()
	{

			$departamento = $this->input->post('departamento');	
			$data = array 
					(				
					'distrito' =>  $this->Paciente_Model->distrito($departamento)
					);
			$this->parser->parse('Paciente/select_distrito.php',$data);
			
			
		
	}
	///////////////
	public function llena_barrio()
	{
		
			$departamento = $this->input->post('depar');	
			$distrito = $this->input->post('dis');	

			$data = array 
					(				
					'barrio' =>  $this->Paciente_Model->barrio($distrito,$departamento)
					);
			$this->parser->parse('Paciente/select_barrio.php',$data);
		
	}

	public function consulta()
	{
		
			//$q = $this->input->post('cedula');
			$cedula =$this->uri->segment(4,0);
			//$sql="select cedula from paciente where cedula =".$q;

			$query = $this->Paciente_Model->consulta($cedula);

			if($query!= false)
			{
				
				$data = array 
					(				
					'result' =>  '',
					);
				$this->parser->parse('Paciente/consulta.php',$data);

			}
			
			
	}
	

}

