<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
 
class Reporte extends CI_Controller {
 
    public function index()
    {
        // Se carga el modelo cliente
        $this->load->model('reporte_modelo');
        // Se carga la libreria fpdf
        $this->load->library('pdf');
 
        // Se obtienen los clientes de la base de datos
        $clientes = $this->reporte_modelo->obtenerListaClientes();
 
        // Creacion del PDF
 
        /*
         * Se crea un objeto de la clase Pdf, recuerda que la clase Pdf
         * heredó todos las variables y métodos de fpdf
         */
        $this->pdf = new Pdf('L','mm','A4');
        // Agregamos una página
        $this->pdf->AddPage();
        // Define el alias para el número de página que se imprimirá en el pie
        $this->pdf->AliasNbPages();
 
        /* Se define el titulo, márgenes izquierdo, derecho y
         * el color de relleno predeterminado
         */
        $this->pdf->SetTitle("Lista de clientes");
        $this->pdf->SetLeftMargin(15);
        $this->pdf->SetRightMargin(15);
        $this->pdf->SetFillColor(200,200,200);
 
        // Se define el formato de fuente: Arial, negritas, tamaño 9
        $this->pdf->SetFont('Arial', 'B', 7);
        /*
         * TITULOS DE COLUMNAS
         *
         * $this->pdf->Cell(Ancho, Alto,texto,borde,posición,alineación,relleno);
         */
		$this->pdf->Cell(6,7,'Nro','TBL',0,'C','1');
        $this->pdf->Cell(15,7,'CI','TBL',0,'C','1');
        $this->pdf->Cell(25,7,'NOMBRES/APELLIDO','TBL',0,'C','1');
       
        $this->pdf->Cell(25,7,'FECHA NAC','TBL',0,'C','1');
        $this->pdf->Cell(25,7,'DIRECCION','TBL',0,'C','1');
        $this->pdf->Cell(25,7,'TELEFONO','TBL',0,'C','1');
       
        $this->pdf->Cell(25,7,'LUGAR DE TRABAJO','TBL',0,'C','1');
        $this->pdf->Cell(25,7,'LIMITE DE CREDITO','TBL',0,'C','1');
        $this->pdf->Ln(7);
        // La variable $x se utiliza para mostrar un número consecutivo
        $x = 1;
        foreach ($clientes as $cliente) {
            // se imprime el numero actual y despues se incrementa el valor de $x en uno
            $this->pdf->Cell(6,5,$x++,'',0,'C',0);
            // Se imprimen los datos de cada cliente
            $this->pdf->Cell(15,5,$cliente->ci,'',0,'L',0);
            $this->pdf->Cell(25,5,$cliente->nombre.' '.$cliente->apellido,'',0,'L',0);
			$this->pdf->Cell(25,5,$cliente->fecha_nac,'',0,'C',0);
            $this->pdf->Cell(25,5,$cliente->direccion,'',0,'L',0);
            $this->pdf->Cell(25,5,$cliente->telefono,'',0,'C',0);
           
            $this->pdf->Cell(25,5,$cliente->lugar_trabajo,'',0,'C',0);
            $this->pdf->Cell(25,5,$cliente->limite_credito,'',0,'C',0);
            //Se agrega un salto de linea
            $this->pdf->Ln(5);
        }
        
        $this->pdf->Output("Lista de clientes.pdf", 'I');
    }
	
	
}
